class Car
{
  int carNum = 0;
  float angle = 0.0;
  int x, y;
  color carColor = color(random(127) + 127, random(127) + 127, random(127) + 127);
  color currColor = carColor;
  color hornColor = color(255, 0, 0);
  float speed = 0.0;
  boolean justWrapped = false;
  
  boolean danger = false;

  Car(int carNum, float angle, float targetSpeed)
  {
    this.carNum = carNum;
    this.angle = angle;
    speed = targetSpeed;
    x = int(sin(angle) * (middleX/2)) + middleX/2 + (trackWidth/2);
    y = int(cos(angle) * (middleX/2)) + middleX/2 + (trackWidth/2);

    print("added car: " + carNum + " angle: " + angle);
  }  

  void draw()
  {      
    stroke(currColor);
    fill(currColor);
    ellipse(x, y, 10, 10);  
  }

  void drive(Car carInFront)
  { 
    currColor = carColor;
    danger = false;
    
    float radiansDistance = abs(angle - carInFront.angle);
    //println("car: " + carNum + " angle: " + angle + " radiansDistance: " + radiansDistance);
    //if car in front is too close, honk horn and slow down!
    if (radiansDistance < dangerRadians)
    {      
      float flux = random(0.005);
      speed -= flux;
      if (speed < 0)
        speed = 0;

      danger = true;
    }
    //if we're really slow, speed up quickly
    else if (speed < 0.02)
    {
      //println("carNum: " + carNum + " too slow, speeding up.");
      speed += 0.0025;
    }
    //randomly wiggle speed a bit
    else if (random(100) < 25.0)
    {
      float flux = random(0.005);
      flux -= 0.0025;
      speed += flux;
      if (speed < 0)
        speed = 0;
    }
    bumpAngle(speed); 

    //println("carNum " + carNum + " speed: " + speed);
  }

  void bumpAngle(float radians)
  {
    angle += radians;

    if (angle > twoPI)
    {
      angle -= twoPI;
      justWrapped = true;
    }
    else
      justWrapped = false;

    x = int(sin(angle) * (middleX/2)) + middleX/2 + (trackWidth/2);
    y = int(cos(angle) * (middleX/2)) + middleX/2 + (trackWidth/2);
  }
}
