static int hornNum = 0;

class SampleCar extends Car
{

  AudioSample horn;
  
  SampleCar(int carNum, float angle, float targetSpeed)
  {  
    super(carNum, angle, targetSpeed);
  
    int whichHorn = hornNum % 8 + 1;
    horn = minim.loadSample("horn" + whichHorn + ".wav"); 
    
    println(" horn sample 'horn" + whichHorn + ".wav' loaded.");

    hornNum++;
  }
  
  //don't call super.draw since we've implemented our own draw routine
  void draw()
  {
    stroke(currColor);
    fill(currColor);
    rect(x - 5, y - 5, 10, 10);  
  }
  
  void drive(Car carInFront)
  {
    super.drive(carInFront);
    
    //keep pan accurate or we get weird blips when we 
    //suddenly set pan and turn up amp...
    float newPan = map(x, 0, width, -1.0, 1.0);
    horn.setPan(newPan);
    
    if (danger)
    {
      currColor = hornColor;
      horn.trigger();
    }
  }
}
