
class SynthCar extends Car
{
  SquareWave horn;
  float hornFreq;
  
  SynthCar(int carNum, float angle, float targetSpeed, AudioOutput output)
  {  
    super(carNum, angle, targetSpeed);
    
    float hornFreq = random(100) + 200;
    horn = new SquareWave(hornFreq, 0.0, 44100);
    output.addSignal(horn);  
    
    println(" horn freq: " + hornFreq);
  }
  
  void draw()
  {
    super.draw();
  }
  
  void drive(Car carInFront)
  {
    horn.setAmp(0.0); 

    //keep pan accurate or we get weird blips when we 
    //suddenly set pan and turn up amp...
    float newPan = map(x, 0, width, -1.0, 1.0);
    horn.setPan(newPan);
    
    super.drive(carInFront);
    
    if (danger)
    {
      currColor = hornColor;
      horn.setAmp(0.25);
    }
  }
}
